<?php
/* Resizes the source image to the desired size.
Maintains the aspect ratio (i.e. does not distort the image).
Supports the following image formats:

GIF, JPEG, PNG, BMP

*/
function pm_resizeimage($format, $new_width, $new_height, $srcfile, $destfile ) {
    $err = TRUE;

	$img_size = getimagesize( $srcfile );
    if( $img_size[0] >= $img_size[1] ) {
        $orientation = 0;
    }
    else {
        $orientation = 1;
        $new_width = $new_height;
        $new_height = $new_width;
    }
    if ( $img_size[0] > $new_width || $img_size[1] > $new_height ) {
        if( ( $img_size[0] - $new_width ) >= ( $img_size[1] - $new_height ) ) {
            $iw = $new_width;
            $ih = ( $new_width / $img_size[0] ) * $img_size[1];
        }
        else {
            $ih = $new_height;
            $iw = ( $ih / $img_size[1] ) * $img_size[0];
        }
        $do_resize = TRUE;
    }

    if ( $do_resize ) {
		// use the correct method for the format type
		if($format == 'jpg' || $format == 'jpeg') {
			$img_src = imagecreatefromjpeg( $srcfile );
		} else if($format == 'png') {
			$img_src = imagecreatefrompng( $srcfile );
		} else if($format == 'bmp') {
			$img_src = imagecreatefromwbmp( $srcfile );
		} else if($format == 'gif') {
			$img_src = imagecreatefromgif( $srcfile );
		}
        $img_dst = imagecreatetruecolor( $iw, $ih );
        imagecopyresampled( $img_dst, $img_src, 0, 0, 0, 0, $iw, $ih, $img_size[0], $img_size[1] );
        
		
		if( ($format == 'jpg' || $format == 'jpeg') && !imagejpeg( $img_dst, $destfile, 90 ) ) {
            $err = FALSE;
        } else if($format == 'png' && !imagepng($img_dst, $destfile, 9)) {
			$err = FALSE;
		} else if($format == 'gif' && !imagegif($img_dst, $destfile)) {
			$err = FALSE;
		} else if($format == 'bmp' && !imagewbmp($img_dst, $destfile)) {
			$err = FALSE;
		}
    }

	return $err;

}
?>